'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.RequestCache = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _models = require('./models');

var _browser = require('ng2-logger/browser');

var _restHeaders = require('./rest-headers');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var log = _browser.Log.create('request-cache', _browser.Level.__NOTHING);

var RequestCache = exports.RequestCache = function () {
    function RequestCache(response) {
        _classCallCheck(this, RequestCache);

        this.response = response;
    }

    _createClass(RequestCache, [{
        key: 'persistsInLocalStorage',
        value: function persistsInLocalStorage() {
            localStorage.setItem(RequestCache.LOCAL_STORAGE_KEY, JSON.stringify(RequestCache.cached.map(function (r) {
                return {
                    response: {
                        sourceRequest: r.response.sourceRequest,
                        responseText: r.response.responseText,
                        headers: r.response.headers,
                        statusCode: r.response.statusCode,
                        entity: r.response.entity,
                        circular: r.response.circular,
                        isArray: r.response.isArray
                    }
                };
            })));
        }
    }, {
        key: 'store',
        value: function store() {
            RequestCache.restoreFromLocalStorage();
            if (!this.containsCache) {
                RequestCache.cached.push(this);
                this.persistsInLocalStorage();
            } else {
                console.log('already stored');
            }
            return this;
        }
    }, {
        key: 'remove',
        value: function remove() {
            RequestCache.restoreFromLocalStorage();
            var index = RequestCache.cached.indexOf(this);
            if (index !== -1) {
                RequestCache.cached.splice(index, 1);
                this.persistsInLocalStorage();
            } else {
                console.log('already removed');
            }
        }
    }, {
        key: 'containsCache',
        get: function get() {
            RequestCache.restoreFromLocalStorage();
            return RequestCache.cached.includes(this);
        }
    }], [{
        key: 'restoreFromLocalStorage',
        value: function restoreFromLocalStorage() {
            if (_browser.Helpers.isNode) {
                return;
            }
            if (!RequestCache.isRestoredFromLocalStorage) {
                RequestCache.isRestoredFromLocalStorage = true;
                var data = localStorage.getItem(RequestCache.LOCAL_STORAGE_KEY);
                var requests = [];
                if (data) {
                    try {
                        requests = JSON.parse(data);
                    } catch (error) {}
                    var restored = requests.map(function (r) {
                        var _r$response = r.response,
                            sourceRequest = _r$response.sourceRequest,
                            responseText = _r$response.responseText,
                            body = _r$response.body,
                            headers = _r$response.headers,
                            circular = _r$response.circular,
                            entity = _r$response.entity,
                            isArray = _r$response.isArray,
                            cookies = _r$response.cookies,
                            statusCode = _r$response.statusCode;

                        r.response = new _models.Models.HttpResponse(sourceRequest, responseText, _restHeaders.RestHeaders.from(headers), statusCode, entity, circular, isArray);
                        r = new RequestCache(r.response);
                        r.response.rq = r;
                        return r;
                    });
                    log.i('RESTORED FROM LOCAL STORAGE', restored);
                    RequestCache.cached = restored;
                }
            }
        }
    }, {
        key: 'findBy',
        value: function findBy(sourceRequest) {
            log.i('findby', sourceRequest);
            log.i('RequestCache.cached', RequestCache.cached);
            RequestCache.restoreFromLocalStorage();
            return RequestCache.cached.find(function (c) {
                var a = c.response.sourceRequest;
                var b = sourceRequest;
                return a.isArray === b.isArray && a.url === b.url && a.method === b.method && a.body === b.body;
            });
        }
    }]);

    return RequestCache;
}();

RequestCache.LOCAL_STORAGE_KEY = 'ng2restrequestcache';
RequestCache.cached = [];
RequestCache.isRestoredFromLocalStorage = false;
//# sourceMappingURL=request-cache.js.map