'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.Resource = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Subject = require('rxjs/Subject');

require('rxjs/add/operator/map');

require('rxjs/add/operator/takeUntil');

require('rxjs/add/operator/take');

require('rxjs/add/operator/toPromise');

var _browser = require('ng2-logger/browser');

var _rest = require('./rest.class');

var _restRequest = require('./rest-request');

var _restHeaders = require('./rest-headers');

var _cookie = require('./cookie');

var _params = require('./params');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var log = _browser.Log.create('resouce-service', _browser.Level.__NOTHING);

if (!global['ENV']) {
    global['ENV'] = {};
}

var Resource = exports.Resource = function () {
    //#endregion
    //#region constructor
    function Resource() {
        var _this = this;

        _classCallCheck(this, Resource);

        setTimeout(function () {
            var zone = _this.getZone();
            if (!_restRequest.RestRequest.zone) _restRequest.RestRequest.zone = zone;
        });
    }

    _createClass(Resource, [{
        key: 'getZone',

        //#region private mthods and fields
        value: function getZone() {
            var isNode = typeof window === 'undefined';
            if (isNode) return;
            var ng = window['ng'];
            var getAllAngularRootElements = window['getAllAngularRootElements'];
            if (!ng || !getAllAngularRootElements) return;
            var probe = ng.probe;
            var coreTokens = ng.coreTokens;
            if (!coreTokens.NgZone) return;
            var zoneClass = coreTokens.NgZone;
            if (!probe || typeof probe !== 'function' || !getAllAngularRootElements) return;
            var angularElements = getAllAngularRootElements();
            if (!Array.isArray(angularElements) || angularElements.length === 0) return;
            var rootElement = ng.probe(angularElements[0]);
            if (!rootElement) return;
            var injector = rootElement.injector;
            if (!injector || !injector.get || typeof injector.get !== 'function') return;
            var zone = injector.get(zoneClass);
            return zone;
        }
    }, {
        key: 'checkNestedModels',
        value: function checkNestedModels(model, allModels) {
            // if (model.indexOf('/') !== -1) { //TODO make this better, becouse now I unecesary checking shit
            for (var p in allModels) {
                if (allModels.hasOwnProperty(p)) {
                    var m = allModels[p];
                    if ((0, _params.isValid)(p)) {
                        var urlModels = (0, _params.getModels)(p);
                        if ((0, _params.containsModels)(model, urlModels)) {
                            model = p;
                            break;
                        }
                    }
                }
            }
            // }
            return model;
        }
    }, {
        key: 'add',

        //#region add
        /**
         * And enipoint to application
         *
         * @param {E} endpoint
         * @param {string} model
         * @returns {boolean}
         */
        value: function add(endpoint, model, entity, circular) {
            log.i('I am maping ' + model + ' on ' + endpoint);
            model = Resource.prepareModel(model);
            var e = void 0;
            e = endpoint.toString();
            if (Resource.endpoints[e] === void 0) {
                console.error('Endpoint is not mapped ! Cannot add model ' + model);
                return;
            }
            if (Resource.endpoints[e].models[model] !== void 0) {
                if (Resource.enableWarnings) console.warn('Model \'' + model + '\' is already defined in endpoint: ' + Resource.endpoints[e].url);
                return;
            }
            Resource.endpoints[e].models[model] = new _rest.Rest(Resource.endpoints[e].url + '/' + model, Resource.request, {
                endpoint: e,
                path: model,
                entity: entity,
                circular: circular
            });
            return;
        }
        //#endregion
        //#region api
        /**
         * Access api throught endpoint
         *
         * @param {E} endpoint
         * @param {string} model
         * @returns {Rest<T, TA>}
         */

    }, {
        key: 'api',
        value: function api(endpoint, model) {
            if (model.charAt(0) === '/') model = model.slice(1, model.length);
            var e = endpoint.toString();
            if (Resource.endpoints[e] === void 0) {
                throw 'Endpoint: ' + endpoint + ' is not mapped ! Cannot add model: ' + model;
            }
            var allModels = Resource.endpoints[e].models;
            var orgModel = model;
            model = this.checkNestedModels(model, allModels);
            if (Resource.endpoints[e].models[model] === void 0) {
                log.d('Resource.endpoints', Resource.endpoints);
                throw 'Model \'' + model + '\' is undefined in endpoint: ' + Resource.endpoints[e].url + ' ';
            }
            var res = Resource.endpoints[endpoint.toString()].models[model];
            if (orgModel !== model) {
                var baseUrl = Resource.endpoints[endpoint.toString()].url;
                log.d('base', Resource.endpoints[endpoint.toString()]);
                log.d('baseUrl', baseUrl);
                log.d('orgModel', orgModel);
                res.__rest_endpoint = baseUrl + '/' + orgModel;
            } else res.__rest_endpoint = void 0;
            return res;
        }
    }], [{
        key: 'initAngularNgZone',
        value: function initAngularNgZone(zone) {
            _restRequest.RestRequest.zone = zone;
        }
    }, {
        key: 'getModel',
        value: function getModel(endpoint, model) {
            model = Resource.prepareModel(model);
            var e = Resource.endpoints[endpoint];
            if (!e) {
                return void 0;
            }
            var r = Resource.endpoints[endpoint].models[model];
            return Resource.endpoints[endpoint].models[model];
        }
        //#endregion
        //#region create

    }, {
        key: 'create',
        value: function create(e, _model, entityMapping, circular) {
            var badRestRegEX = new RegExp('((\/:)[a-z]+)+', 'g');
            var matchArr = _model.match(badRestRegEX) || [];
            var badModelsNextToEachOther = matchArr.join();
            var atleas2DoubleDots = (badModelsNextToEachOther.match(new RegExp(':', 'g')) || []).length >= 2;
            if (atleas2DoubleDots && _model.search(badModelsNextToEachOther) !== -1) {
                throw new Error('\nBad rest model: ' + _model + '\nDo not create rest models like this:    /book/author/:bookid/:authorid\nInstead use nested approach:            /book/:bookid/author/:authorid\n            ');
            }
            ;
            Resource.map(e, e);
            Resource.instance.add(e, _model ? _model : '', entityMapping, circular);
            // if (model.charAt(model.length - 1) !== '/') model = `${model}/`;
            return {
                model: function model(params) {
                    return Resource.instance.api(e, (0, _params.interpolateParamsToUrl)(params, _model));
                },
                replay: function replay(method) {
                    Resource.getModel(e, _model).replay(method);
                },
                get headers() {
                    return Resource.getModel(e, _model).headers;
                }
            };
        }
        //#endregion
        //#region reset

    }, {
        key: 'reset',
        value: function reset() {
            Resource.endpoints = {};
        }
        //#region map

    }, {
        key: 'map',
        value: function map(endpoint, url) {
            log.i('url', url);
            var regex = /(http|https):\/\/(\w+:{0,1}\w*)?(\S+)(:[0-9]+)?(\/|\/([\w#!:.?+=&%!\-\/]))?/;
            var e = endpoint;
            if (!regex.test(url)) {
                throw 'Url address is not correct: ' + url;
            }
            if (url.charAt(url.length - 1) === '/') url = url.slice(0, url.length - 1);
            log.i('url after', url);
            if (Resource.endpoints[e] !== void 0) {
                !global.hideLog && console.warn('Cannot use map function at the same API endpoint again (' + Resource.endpoints[e].url + ')');
                return false;
            }
            Resource.endpoints[e] = {
                url: url,
                models: {},
                entity: null
            };
            log.i('enpoints', Resource.endpoints);
            return true;
        }
        //#endregion

    }, {
        key: 'prepareModel',
        value: function prepareModel(model) {
            if (model.charAt(model.length - 1) === '/') model = model.slice(0, model.length - 1);
            if (model.charAt(0) === '/') model = model.slice(1, model.length);
            return model;
        }
    }, {
        key: 'listenErrors',
        get: function get() {
            return this._listenErrors.asObservable();
        }
    }]);

    return Resource;
}();

Resource.DEFAULT_HEADERS = _restHeaders.RestHeaders.from({
    'Content-Type': 'application/json',
    'Accept': 'application/json'
});
Resource._listenErrors = new _Subject.Subject();
Resource.enableWarnings = true;
Resource.instance = new Resource();
Resource.endpoints = {};
Resource.request = new _restRequest.RestRequest();
//#endregion
Resource.Cookies = _cookie.Cookie.Instance;
// const res = Resource.create('')
// res.model()
//   .mock({
//     code: 500,
//     data: {},
//     isArray: true
//   })
//   .array.
//# sourceMappingURL=resource.service.js.map