'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.RestRequest = undefined;

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _tslib = require('tslib');

var _Subject = require('rxjs/Subject');

require('rxjs/add/operator/map');

require('rxjs/add/operator/takeUntil');

require('rxjs/add/operator/take');

var _lodash = require('lodash');

var _ = _interopRequireWildcard(_lodash);

var _models = require('./models');

var _restHeaders = require('./rest-headers');

var _browser = require('ng2-logger/browser');

var _axios = require('axios');

var _axios2 = _interopRequireDefault(_axios);

var _resource = require('./resource.service');

var _util = require('util');

var _requestCache = require('./request-cache');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var log = _browser.Log.create('rest-resource', _browser.Level.__NOTHING);
var jobIDkey = 'jobID';
if (!global['ENV']) {
    global['ENV'] = {};
}
//#region mock request
//#endregion

var RestRequest = exports.RestRequest = function () {
    function RestRequest() {
        _classCallCheck(this, RestRequest);

        this.subjectInuUse = {};
        this.meta = {};
        //#endregion
        this.replaySubjects = {};
    }

    _createClass(RestRequest, [{
        key: 'handlerResult',
        value: function handlerResult(options, sourceRequest) {
            if ((0, _util.isUndefined)(options)) {
                options = {};
            }
            log.d('[ng2-rest] ' + sourceRequest.url);
            var _options = options,
                res = _options.res,
                jobid = _options.jobid,
                isArray = _options.isArray,
                method = _options.method;

            if ((typeof res === 'undefined' ? 'undefined' : _typeof(res)) !== 'object') throw new Error('[ng2-rest] No resposnse for request. ');
            if (_browser.Helpers.isBrowser) {
                res.headers = _restHeaders.RestHeaders.from(res.headers);
            }
            // error no internet
            if (res.error) {
                this.subjectInuUse[jobid].error(new _models.Models.HttpResponseError(res.error, res.data, res.headers, res.code));
                return;
            }
            var entity = this.meta[jobid].entity;
            var circular = this.meta[jobid].circular;
            // normal request case
            this.subjectInuUse[jobid].next(new _models.Models.HttpResponse(sourceRequest, res.data, res.headers, res.code, entity, circular, isArray));
            return;
        }
    }, {
        key: 'checkCache',
        value: function checkCache(sourceRequest, jobid) {
            var existedInCache = _requestCache.RequestCache.findBy(sourceRequest);
            if (existedInCache) {
                log.i('cache exists', existedInCache);
                this.subjectInuUse[jobid].next(existedInCache);
                return true;
            }
            log.i('cache not exists', existedInCache);
            return false;
        }
    }, {
        key: 'req',
        value: function req(url, method, headers, body, jobid) {
            var isArray = arguments.length > 5 && arguments[5] !== undefined ? arguments[5] : false;
            var mockHttp = arguments[6];

            return (0, _tslib.__awaiter)(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
                var response, r, err, msg, stack, error;
                return regeneratorRuntime.wrap(function _callee$(_context) {
                    while (1) {
                        switch (_context.prev = _context.next) {
                            case 0:
                                if (!this.checkCache({
                                    url: url,
                                    body: body,
                                    isArray: isArray,
                                    method: method
                                }, jobid)) {
                                    _context.next = 2;
                                    break;
                                }

                                return _context.abrupt('return');

                            case 2:
                                if (mockHttp) {
                                    if ((typeof mockHttp === 'undefined' ? 'undefined' : _typeof(mockHttp)) === 'object') {
                                        response = {
                                            data: mockHttp.data,
                                            status: mockHttp.code,
                                            headers: mockHttp.headers,
                                            statusText: mockHttp.error,
                                            config: {}
                                        };
                                    } else if (typeof mockHttp === 'function') {
                                        r = mockHttp(url, method, headers, body);

                                        response = {
                                            data: r.data,
                                            status: r.code,
                                            headers: r.headers,
                                            statusText: r.error,
                                            config: {}
                                        };
                                    }
                                }
                                _context.prev = 3;

                                if (response) {
                                    _context.next = 8;
                                    break;
                                }

                                _context.next = 7;
                                return (0, _axios2.default)({
                                    url: url,
                                    method: method,
                                    data: body,
                                    responseType: 'text',
                                    headers: headers.toJSON()
                                });

                            case 7:
                                response = _context.sent;

                            case 8:
                                this.handlerResult({
                                    res: {
                                        code: response.status,
                                        data: JSON.stringify(response.data),
                                        isArray: isArray,
                                        jobid: jobid,
                                        headers: _restHeaders.RestHeaders.from(response.headers)
                                    },
                                    method: method,
                                    jobid: jobid,
                                    isArray: isArray
                                }, {
                                    url: url,
                                    body: body,
                                    method: method,
                                    isArray: isArray
                                });
                                _context.next = 16;
                                break;

                            case 11:
                                _context.prev = 11;
                                _context.t0 = _context['catch'](3);

                                // console.log('ERROR RESPONESE catchedError typeof ', typeof catchedError)
                                // console.log('ERROR RESPONESE catchedError', catchedError)
                                if ((typeof _context.t0 === 'undefined' ? 'undefined' : _typeof(_context.t0)) === 'object' && _context.t0.response && _context.t0.response.data) {
                                    err = _context.t0.response.data;
                                    msg = _context.t0.response.data.message || '';
                                    stack = (err.stack || '').split('\n');

                                    _resource.Resource['_listenErrors'].next({
                                        msg: msg,
                                        stack: stack,
                                        data: _context.t0.response.data
                                    });
                                }
                                error = _context.t0 && _context.t0.response ? '[' + _context.t0.response.statusText + ']: ' : '';

                                this.handlerResult({
                                    res: {
                                        code: _context.t0 && _context.t0.response ? _context.t0.response.status : void 0,
                                        error: '' + error + _context.t0.message,
                                        data: _context.t0 && _context.t0.response ? JSON.stringify(_context.t0.response.data) : void 0,
                                        isArray: isArray,
                                        jobid: jobid,
                                        headers: _restHeaders.RestHeaders.from(_context.t0 && _context.t0.response && _context.t0.response.headers)
                                    },
                                    method: method,
                                    jobid: jobid,
                                    isArray: isArray
                                }, {
                                    url: url,
                                    body: body,
                                    isArray: isArray,
                                    method: method
                                });

                            case 16:
                            case 'end':
                                return _context.stop();
                        }
                    }
                }, _callee, this, [[3, 11]]);
            }));
        }
    }, {
        key: 'getSubject',
        value: function getSubject(method, meta) {
            if (_.isUndefined(this.replaySubjects[meta.endpoint])) {
                log.i('[getSubject][recreate] (' + meta.endpoint + ') ');
                this.replaySubjects[meta.endpoint] = {};
            }
            if (_.isUndefined(this.replaySubjects[meta.endpoint][meta.path])) {
                log.i('[getSubject][recreate] (' + meta.endpoint + ')(' + meta.path + ') ');
                this.replaySubjects[meta.endpoint][meta.path] = {};
            }
            if (_.isUndefined(this.replaySubjects[meta.endpoint][meta.path][method])) {
                log.i('[getSubject][recreate] (' + meta.endpoint + ')(' + meta.path + ')(' + method + ') ');
                this.replaySubjects[meta.endpoint][meta.path][method] = {
                    subject: new _Subject.Subject(),
                    data: void 0
                };
            }
            var replay = this.replaySubjects[meta.endpoint][meta.path][method];
            var id = RestRequest.jobId++;
            replay.id = id;
            var subject = replay.subject;
            subject[jobIDkey] = id;
            this.meta[id] = meta;
            this.subjectInuUse[id] = subject;
            return replay;
        }
        //#region http methods

    }, {
        key: 'metaReq',
        value: function metaReq(method, url, body, headers, meta, isArray, mockHttp) {
            var _this = this;

            var replay = this.getSubject(method, meta);
            replay.data = { url: url, body: body, headers: headers, isArray: isArray };
            setTimeout(function () {
                return _this.req(url, method, headers, body, replay.id, isArray, mockHttp);
            });
            var resp = replay.subject.asObservable().take(1).toPromise();
            resp.observable = replay.subject.asObservable();
            resp.cache = _requestCache.RequestCache.findBy({
                body: body,
                isArray: isArray,
                method: method,
                url: url
            });
            return resp;
        }
    }, {
        key: 'get',
        value: function get(url, body, headers, meta, isArray, mockHttp) {
            return this.metaReq('get', url, body, headers, meta, isArray, mockHttp);
        }
    }, {
        key: 'head',
        value: function head(url, body, headers, meta, isArray, mockHttp) {
            return this.metaReq('head', url, body, headers, meta, isArray, mockHttp);
        }
    }, {
        key: 'delete',
        value: function _delete(url, body, headers, meta, isArray, mockHttp) {
            return this.metaReq('delete', url, body, headers, meta, isArray, mockHttp);
        }
    }, {
        key: 'post',
        value: function post(url, body, headers, meta, isArray, mockHttp) {
            return this.metaReq('post', url, body, headers, meta, isArray, mockHttp);
        }
    }, {
        key: 'put',
        value: function put(url, body, headers, meta, isArray, mockHttp) {
            return this.metaReq('put', url, body, headers, meta, isArray, mockHttp);
        }
    }, {
        key: 'patch',
        value: function patch(url, body, headers, meta, isArray, mockHttp) {
            return this.metaReq('patch', url, body, headers, meta, isArray, mockHttp);
        }
    }, {
        key: 'jsonp',
        value: function jsonp(url, body, headers, meta, isArray, mockHttp) {
            var _this2 = this;

            var replay = this.getSubject('jsonp', meta);
            var jobid = replay.id;
            var method = 'jsonp';
            setTimeout(function () {
                if (url.endsWith('/')) url = url.slice(0, url.length - 1);
                var num = Math.round(10000 * Math.random());
                var callbackMethodName = "cb_" + num;
                window[callbackMethodName] = function (data) {
                    if (_this2.checkCache({
                        url: url,
                        body: body,
                        isArray: isArray,
                        method: method
                    }, jobid)) {
                        return;
                    }
                    _this2.handlerResult({
                        res: {
                            data: data, isArray: isArray
                        },
                        method: method,
                        jobid: jobid,
                        isArray: isArray
                    }, {
                        url: url,
                        body: body,
                        isArray: isArray,
                        method: method
                    });
                };
                var sc = document.createElement('script');
                sc.src = url + '?callback=' + callbackMethodName;
                document.body.appendChild(sc);
                document.body.removeChild(sc);
            });
            // return replay.subject.asObservable();
            var resp = replay.subject.asObservable().take(1).toPromise();
            resp.observable = replay.subject.asObservable();
            resp.cache = _requestCache.RequestCache.findBy({
                body: body,
                isArray: isArray,
                method: method,
                url: url
            });
            return resp;
        }
    }, {
        key: 'replay',
        value: function replay(method, meta) {
            var _this3 = this;

            var replay = this.getSubject(method, meta);
            if (!replay.data) {
                console.warn('Canno replay first ' + method + ' request from ' + meta.endpoint + '/' + meta.path);
                return;
            }
            ;
            if (replay && replay.subject && Array.isArray(replay.subject.observers) && replay.subject.observers.length == 0) {
                console.warn('No observators for ' + method + ' request from ' + meta.endpoint + '/' + meta.path);
                return;
            }
            var url = replay.data.url;
            var headers = replay.data.headers;
            var body = replay.data.body;
            var isArray = replay.data.isArray;
            setTimeout(function () {
                return _this3.req(url, method, headers, body, replay.id, isArray);
            });
        }
    }]);

    return RestRequest;
}();

RestRequest.jobId = 0;
//# sourceMappingURL=rest-request.js.map