'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.Models = undefined;

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

require('rxjs/add/operator/map');

var _browser = require('ng2-logger/browser');

var _cookie = require('./cookie');

var _mapping = require('./mapping');

var _browser2 = require('typescript-class-helpers/browser');

var _browser3 = require('json10/browser');

var _requestCache = require('./request-cache');

var _lodash = require('lodash');

var _ = _interopRequireWildcard(_lodash);

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) newObj[key] = obj[key]; } } newObj.default = obj; return newObj; } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var log = _browser.Log.create('rest namespace', _browser.Level.__NOTHING);
var Models = exports.Models = undefined;
(function (Models) {
    Models.MethodConfig = _browser2.Models.MethodConfig;
    Models.ClassConfig = _browser2.Models.ClassConfig;
    Models.ParamConfig = _browser2.Models.ParamConfig;
    ;
    ;
    [];

    var BaseBody = function () {
        function BaseBody() {
            _classCallCheck(this, BaseBody);
        }

        _createClass(BaseBody, [{
            key: 'toJSON',
            value: function toJSON(data) {
                var isJSONArray = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

                var r = isJSONArray ? [] : {};
                if (typeof data === 'string') {
                    try {
                        r = JSON.parse(data);
                    } catch (e) {}
                } else if ((typeof data === 'undefined' ? 'undefined' : _typeof(data)) === 'object') {
                    return data;
                }
                return r;
            }
        }]);

        return BaseBody;
    }();

    Models.BaseBody = BaseBody;

    var HttpBody = function (_BaseBody) {
        _inherits(HttpBody, _BaseBody);

        function HttpBody(body) {
            var isArray = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;
            var entity = arguments[2];
            var circular = arguments[3];

            _classCallCheck(this, HttpBody);

            var _this = _possibleConstructorReturn(this, (HttpBody.__proto__ || Object.getPrototypeOf(HttpBody)).call(this));

            _this.body = body;
            _this.isArray = isArray;
            _this.entity = entity;
            _this.circular = circular;
            return _this;
        }

        _createClass(HttpBody, [{
            key: 'booleanValue',
            get: function get() {
                return ['ok', 'true'].includes(this.body.trim());
            }
        }, {
            key: 'json',
            get: function get() {
                if (this.entity && _typeof(this.entity) === 'object') {
                    var json = this.toJSON(this.body, this.isArray);
                    return _mapping.Mapping.encode(json, this.entity, this.circular);
                }
                var res = this.toJSON(this.body, this.isArray);
                if (this.circular && Array.isArray(this.circular)) {
                    res = _browser3.JSON10.parse(JSON.stringify(res), this.circular);
                }
                return res;
            }
        }, {
            key: 'text',
            get: function get() {
                return this.body.replace(/^\"/, '').replace(/\"$/, '');
            }
        }]);

        return HttpBody;
    }(BaseBody);

    Models.HttpBody = HttpBody;

    var ErrorBody = function (_BaseBody2) {
        _inherits(ErrorBody, _BaseBody2);

        function ErrorBody(data) {
            _classCallCheck(this, ErrorBody);

            var _this2 = _possibleConstructorReturn(this, (ErrorBody.__proto__ || Object.getPrototypeOf(ErrorBody)).call(this));

            _this2.data = data;
            return _this2;
        }

        _createClass(ErrorBody, [{
            key: 'json',
            get: function get() {
                return this.toJSON(this.data);
            }
        }, {
            key: 'text',
            get: function get() {
                return this.data;
            }
        }]);

        return ErrorBody;
    }(BaseBody);

    Models.ErrorBody = ErrorBody;

    var BaseResponse = function () {
        function BaseResponse(responseText, headers, statusCode) {
            var isArray = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;

            _classCallCheck(this, BaseResponse);

            this.responseText = responseText;
            this.headers = headers;
            this.statusCode = statusCode;
            this.isArray = isArray;
        }

        _createClass(BaseResponse, [{
            key: 'cookies',
            get: function get() {
                return BaseResponse.cookies;
            }
        }]);

        return BaseResponse;
    }();

    BaseResponse.cookies = _cookie.Cookie.Instance;
    Models.BaseResponse = BaseResponse;

    var HttpResponse = function (_BaseResponse) {
        _inherits(HttpResponse, _BaseResponse);

        function HttpResponse(sourceRequest, responseText, headers, statusCode, entity, circular) {
            var isArray = arguments.length > 6 && arguments[6] !== undefined ? arguments[6] : false;

            _classCallCheck(this, HttpResponse);

            var _this3 = _possibleConstructorReturn(this, (HttpResponse.__proto__ || Object.getPrototypeOf(HttpResponse)).call(this, responseText, headers, statusCode, isArray));

            _this3.sourceRequest = sourceRequest;
            _this3.responseText = responseText;
            _this3.headers = headers;
            _this3.statusCode = statusCode;
            _this3.entity = entity;
            _this3.circular = circular;
            _this3.isArray = isArray;
            _this3.init();
            return _this3;
        }

        _createClass(HttpResponse, [{
            key: 'init',
            value: function init() {
                if (typeof this.entity === 'string') {
                    // const headerWithMapping = headers.get(entity);
                    var entityJSON = this.headers.getAll(this.entity);
                    if (!!entityJSON) {
                        this.entity = JSON.parse(entityJSON.join());
                    }
                }
                if (typeof this.circular === 'string') {
                    // const headerWithMapping = headers.get(circular);
                    var circuralJSON = this.headers.getAll(this.circular);
                    if (!!circuralJSON) {
                        this.circular = JSON.parse(circuralJSON.join());
                    }
                }
                this.body = new HttpBody(this.responseText, this.isArray, this.entity, this.circular);
            }
        }, {
            key: 'cache',
            get: function get() {
                if (_.isUndefined(this.rq)) {
                    this.rq = new _requestCache.RequestCache(this);
                }
                return new _requestCache.RequestCache(this);
            }
        }]);

        return HttpResponse;
    }(BaseResponse);

    Models.HttpResponse = HttpResponse;

    var HttpResponseError = function (_BaseResponse2) {
        _inherits(HttpResponseError, _BaseResponse2);

        // public tryRecconect() {
        // }
        function HttpResponseError(message, responseText, headers, statusCode) {
            _classCallCheck(this, HttpResponseError);

            var _this4 = _possibleConstructorReturn(this, (HttpResponseError.__proto__ || Object.getPrototypeOf(HttpResponseError)).call(this, responseText, headers, statusCode));

            _this4.message = message;
            _this4.body = new ErrorBody(responseText);
            return _this4;
        }

        return HttpResponseError;
    }(BaseResponse);

    Models.HttpResponseError = HttpResponseError;
})(Models || (exports.Models = Models = {}));
//# sourceMappingURL=models.js.map