'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.Rest = exports.DEFAULT_HEADERS = undefined;

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

require('rxjs/add/operator/map');

var _browser = require('ng2-logger/browser');

var _params = require('./params');

var _restHeaders = require('./rest-headers');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var log = _browser.Log.create('rest.class', _browser.Level.__NOTHING);

//#endregion
var DEFAULT_HEADERS = exports.DEFAULT_HEADERS = {
    'Content-Type': 'application/json',
    'Accept': 'application/json'
};

var Rest = function () {
    function Rest(endpoint, request, meta) {
        var _this = this;

        _classCallCheck(this, Rest);

        this.request = request;
        this.meta = meta;
        //#endregion
        //#region  constructor
        this._headers = _restHeaders.RestHeaders.from(DEFAULT_HEADERS);
        //#endregion
        this.array = {
            get: function get() {
                var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : void 0;
                var doNotSerializeParams = arguments[1];

                return _this.req('get', void 0, params, doNotSerializeParams, true);
            },
            head: function head() {
                var params = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : void 0;
                var doNotSerializeParams = arguments[1];

                return _this.req('head', void 0, params, doNotSerializeParams, true);
            },
            post: function post(item, params, doNotSerializeParams) {
                return _this.req('post', item, params, doNotSerializeParams, true);
            },
            put: function put(item, params, doNotSerializeParams) {
                return _this.req('put', item, params, doNotSerializeParams, true);
            },
            patch: function patch(item, params, doNotSerializeParams) {
                return _this.req('patch', item, params, doNotSerializeParams, true);
            },
            delete: function _delete(params, doNotSerializeParams) {
                return _this.req('delete', void 0, params, doNotSerializeParams, true);
            },
            jsonp: function jsonp(params, doNotSerializeParams) {
                return _this.req('jsonp', void 0, params, doNotSerializeParams, true);
            }
        };
        this.__meta_endpoint = endpoint;
    }

    _createClass(Rest, [{
        key: 'mock',
        value: function mock(_mock) {
            if (typeof _mock === 'function' || (typeof _mock === 'undefined' ? 'undefined' : _typeof(_mock)) === 'object') {
                this.mockHttp = _mock;
            } else {
                throw '[ng2-rest]\n      .model(...)\n      .mock( < BAD MOCK DATA > )\n      ...\n      ';
            }
            return this;
        }
    }, {
        key: 'creatUrl',
        value: function creatUrl(params) {
            var doNotSerializeParams = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

            return '' + this.endpoint + (0, _params.getParamsUrl)(params, doNotSerializeParams);
        }
    }, {
        key: 'req',

        //#endregion
        //#region  req
        value: function req(method, item, params) {
            var doNotSerializeParams = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : false;
            var isArray = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : false;

            var modelUrl = this.creatUrl(params, doNotSerializeParams);
            var body = item ? JSON.stringify(item) : void 0;
            var result = this.request[method.toLowerCase()](modelUrl, body, this.headers, this.meta, isArray, this.mockHttp);
            this._headers = _restHeaders.RestHeaders.from(DEFAULT_HEADERS);
            this.mockHttp = void 0;
            return result;
        }
        //#endregion
        //#region http methods
        //#region replay

    }, {
        key: 'replay',
        value: function replay(method) {
            this.request.replay(method, this.meta);
        }
    }, {
        key: 'get',
        value: function get(params) {
            var doNotSerializeParams = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

            return this.req('get', void 0, params, doNotSerializeParams);
        }
    }, {
        key: 'head',
        value: function head(params) {
            var doNotSerializeParams = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

            return this.req('head', void 0, params, doNotSerializeParams);
        }
    }, {
        key: 'post',
        value: function post(item, params) {
            var doNotSerializeParams = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

            return this.req('post', item, params, doNotSerializeParams);
        }
    }, {
        key: 'put',
        value: function put(item, params) {
            var doNotSerializeParams = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

            return this.req('put', item, params, doNotSerializeParams);
        }
    }, {
        key: 'patch',
        value: function patch(item, params) {
            var doNotSerializeParams = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : false;

            return this.req('patch', item, params, doNotSerializeParams);
        }
    }, {
        key: 'delete',
        value: function _delete(params) {
            var doNotSerializeParams = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

            return this.req('delete', void 0, params, doNotSerializeParams);
        }
    }, {
        key: 'jsonp',
        value: function jsonp(params) {
            var doNotSerializeParams = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : false;

            return this.req('jsonp', void 0, params, doNotSerializeParams);
        }
    }, {
        key: 'endpoint',
        get: function get() {
            var e = this.__meta_endpoint;
            if (this.restQueryParams !== void 0 && this._endpointRest !== void 0 && typeof this._endpointRest === 'string' && this._endpointRest.trim() !== '') e = this._endpointRest;
            return e;
        }
    }, {
        key: '__rest_endpoint',
        set: function set(endpoint) {
            this._endpointRest = endpoint;
            if (endpoint === void 0) {
                this.restQueryParams = void 0;
            } else {
                this.restQueryParams = (0, _params.getRestParams)(endpoint, this.__meta_endpoint);
            }
        }
    }, {
        key: 'headers',
        get: function get() {
            return this._headers;
        }
    }]);

    return Rest;
}();
//# sourceMappingURL=rest.class.js.map


exports.Rest = Rest;