'use strict';

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.SimpleResource = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _Observable = require('rxjs/Observable');

require('rxjs/add/operator/map');

require('rxjs/add/operator/takeUntil');

require('rxjs/add/operator/take');

require('rxjs/add/operator/toPromise');

var _resource = require('./resource.service');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

/**
 *
 * @export
 * @abstract
 * @class SimpleResource
 * @extends {Resource<T, A, TA>}
 * @template E  Endpoint type
 * @template A Single modle type
 * @template TA Array Model Type
 * @template RP rest url parameters type
 * @template QP query parameter type
 */
var ExtendedResource =
// add(endpoint: E, model: string, group?: string, name?: string, description?: string) { }
function ExtendedResource(endpoint, path_model) {
    var _this = this;

    _classCallCheck(this, ExtendedResource);

    this.endpoint = endpoint;
    this.path_model = path_model;
    /**
     * Get model by rest params
    */
    this.model = function (restParams) {
        return {
            get: function get(queryPrams) {
                return _Observable.Observable.create(function (observer) {
                    ExtendedResource.handlers.push(_this.rest.model(restParams).get([queryPrams], ExtendedResource.doNotSerializeQueryParams).observable.subscribe(function (data) {
                        return observer.next(data.body.json);
                    }, function (err) {
                        return observer.error(err);
                    }, function () {
                        return observer.complete();
                    }));
                });
            },
            patch: function patch(item, queryParams) {
                return _Observable.Observable.create(function (observer) {
                    ExtendedResource.handlers.push(_this.rest.model(restParams).put(item, [queryParams], ExtendedResource.doNotSerializeQueryParams).observable.subscribe(function (data) {
                        return observer.next(data.body.json);
                    }, function (err) {
                        return observer.error(err);
                    }, function () {
                        return observer.complete();
                    }));
                });
            },
            head: function head(queryPrams) {
                return _Observable.Observable.create(function (observer) {
                    ExtendedResource.handlers.push(_this.rest.model(restParams).head([queryPrams], ExtendedResource.doNotSerializeQueryParams).observable.subscribe(function (data) {
                        return observer.next(data.body.json);
                    }, function (err) {
                        return observer.error(err);
                    }, function () {
                        return observer.complete();
                    }));
                });
            },
            query: function query(queryPrams) {
                return _Observable.Observable.create(function (observer) {
                    ExtendedResource.handlers.push(_this.rest.model(restParams).array.get([queryPrams], ExtendedResource.doNotSerializeQueryParams).observable.subscribe(function (data) {
                        return observer.next(data.body.json);
                    }, function (err) {
                        return observer.error(err);
                    }, function () {
                        return observer.complete();
                    }));
                });
            },
            post: function post(item, queryParams) {
                return _Observable.Observable.create(function (observer) {
                    ExtendedResource.handlers.push(_this.rest.model(restParams).post(item, [queryParams], ExtendedResource.doNotSerializeQueryParams).observable.subscribe(function (data) {
                        return observer.next(data.body.json);
                    }, function (err) {
                        return observer.error(err);
                    }, function () {
                        return observer.complete();
                    }));
                });
            },
            put: function put(item, queryParams) {
                return _Observable.Observable.create(function (observer) {
                    ExtendedResource.handlers.push(_this.rest.model(restParams).put(item, [queryParams], ExtendedResource.doNotSerializeQueryParams).observable.subscribe(function (data) {
                        return observer.next(data.body.json);
                    }, function (err) {
                        return observer.error(err);
                    }, function () {
                        return observer.complete();
                    }));
                });
            },
            delete: function _delete(queryPrams) {
                return _Observable.Observable.create(function (observer) {
                    ExtendedResource.handlers.push(_this.rest.model(restParams).delete([queryPrams], ExtendedResource.doNotSerializeQueryParams).observable.subscribe(function (data) {
                        return observer.next(data.body.json);
                    }, function (err) {
                        return observer.error(err);
                    }, function () {
                        return observer.complete();
                    }));
                });
            }
        };
    };
    this.rest = _resource.Resource.create(endpoint, path_model);
};

ExtendedResource.doNotSerializeQueryParams = false;
ExtendedResource.handlers = [];
/**
 *
 * @export
 * @class SimpleResource
 * @template A single model type
 * @template TA array model type
 * @template RP rest parameters type
 * @template QP query parameters type
 */

var SimpleResource = exports.SimpleResource = function () {
    function SimpleResource(endpoint, model) {
        _classCallCheck(this, SimpleResource);

        var rest = new ExtendedResource(endpoint, model);
        this.model = rest.model;
    }

    _createClass(SimpleResource, null, [{
        key: '__destroy',
        value: function __destroy() {
            ExtendedResource.handlers.forEach(function (h) {
                return h.unsubscribe();
            });
        }
    }, {
        key: 'doNotSerializeQueryParams',
        set: function set(value) {
            if (!SimpleResource._isSetQueryParamsSerialization) {
                SimpleResource._isSetQueryParamsSerialization = true;
                ExtendedResource.doNotSerializeQueryParams = value;
                return;
            }
            console.warn('Query params serialization already set as\n        ' + ExtendedResource.doNotSerializeQueryParams + ',');
        }
    }]);

    return SimpleResource;
}();

SimpleResource._isSetQueryParamsSerialization = false;
//# sourceMappingURL=simple-resource.js.map